Package ghidra.app.plugin.assembler.sleigh.expr

# Class AbstractUnaryExpressionSolver<T extends UnaryExpression>

java.lang.Object
ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver<T>
ghidra.app.plugin.assembler.sleigh.expr.AbstractUnaryExpressionSolver<T>

Type Parameters:
  `T` - the type of expression solved (the operator)

Direct Known Subclasses:
  `MinusExpressionSolver`, `NotExpressionSolver`

public abstract class AbstractUnaryExpressionSolver<T extends UnaryExpression> extends AbstractExpressionSolver<T>
A solver that handles expressions of the form `[OP]A`

- ## Field Summary

  ### Fields inherited from class ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver

  `dbg, solver`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractUnaryExpressionSolver(Class<T> tcls)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract MaskedLong`
  `compute(MaskedLong val)`
  Compute the result of applying the operator to the given value
  `MaskedLong`
  `computeInverse(MaskedLong goal)`
  Compute the input value given that the result is known
  `int`
  `getInstructionLength(T exp)`
  Determines the length of the subconstructor that would be returned had the expression not depended on an undefined symbol.
  `MaskedLong`
  `getValue(T exp, Map<String,Long> vals, AssemblyResolvedPatterns cur)`
  Attempt to get a constant value for the expression
  `AssemblyResolution`
  `solve(T exp, MaskedLong goal, Map<String,Long> vals, AssemblyResolvedPatterns cur, Set<SolverHint> hints, String description)`
  Attempt to solve an expression for a given value
  `MaskedLong`
  `valueForResolution(T exp, Map<String,Long> vals, AssemblyResolvedPatterns rc)`
  Compute the value of the expression given the (possibly-intermediate) resolution

  ### Methods inherited from class ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver

  `register`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### AbstractUnaryExpressionSolver

    public AbstractUnaryExpressionSolver(Class<T> tcls)

- ## Method Details

  - ### solve

    public AssemblyResolution solve(T exp, MaskedLong goal, Map<String,Long> vals, AssemblyResolvedPatterns cur, Set<SolverHint> hints, String description) throws NeedsBackfillException
    Description copied from class: `AbstractExpressionSolver`
    Attempt to solve an expression for a given value
    Specified by:
      `solve` in class `AbstractExpressionSolver<T extends UnaryExpression>`
    Parameters:
      `exp` - the expression to solve
      `goal` - the desired value of the expression
      `vals` - values of defined symbols
      `hints` - describes techniques applied by calling solvers
      `description` - the description to give to resolved solutions
    Returns:
      the resolution
    Throws:
      `NeedsBackfillException` - if the expression refers to an undefined symbol

  - ### getValue

    public MaskedLong getValue(T exp, Map<String,Long> vals, AssemblyResolvedPatterns cur) throws NeedsBackfillException
    Description copied from class: `AbstractExpressionSolver`
    Attempt to get a constant value for the expression
    Specified by:
      `getValue` in class `AbstractExpressionSolver<T extends UnaryExpression>`
    Parameters:
      `exp` - the expression
      `vals` - values of defined symbols
    Returns:
      the constant value, or null if it depends on a variable
    Throws:
      `NeedsBackfillException` - if the expression refers to an undefined symbol

  - ### computeInverse

    public MaskedLong computeInverse(MaskedLong goal)
    Compute the input value given that the result is known

    NOTE: Assumes an involution by default

    Parameters:
      `goal` - the result
    Returns:
      the input value solution

  - ### compute

    public abstract MaskedLong compute(MaskedLong val)
    Compute the result of applying the operator to the given value
    Parameters:
      `val` - the input value
    Returns:
      the result

  - ### getInstructionLength

    public int getInstructionLength(T exp)
    Description copied from class: `AbstractExpressionSolver`
    Determines the length of the subconstructor that would be returned had the expression not depended on an undefined symbol.

    This is used by the backfilling process to ensure values are written to the correct offset

    Specified by:
      `getInstructionLength` in class `AbstractExpressionSolver<T extends UnaryExpression>`
    Parameters:
      `exp` - the expression
    Returns:
      the length of filled in token field(s).

  - ### valueForResolution

    public MaskedLong valueForResolution(T exp, Map<String,Long> vals, AssemblyResolvedPatterns rc)
    Description copied from class: `AbstractExpressionSolver`
    Compute the value of the expression given the (possibly-intermediate) resolution
    Specified by:
      `valueForResolution` in class `AbstractExpressionSolver<T extends UnaryExpression>`
    Parameters:
      `exp` - the expression to evaluate
      `vals` - values of defined symbols
      `rc` - the resolution on which to evaluate it
    Returns:
      the result